###############################################################################
######### lightOS Makfile                                            ##########
###############################################################################
include ../../../Makefile.config
include ../../../Makefile.rules

.PHONY : get

LIBPNG_VERSION= 1.2.35

# TODO: Empty file pnggccrd.c pngvcrd.c
SRC_C= $(patsubst %,src/%, png.c pngerror.c pngget.c pngmem.c pngpread.c pngread.c pngrio.c pngrtran.c pngrutil.c pngset.c pngtrans.c pngwio.c pngwrite.c pngwtran.c)
OBJ_C= $(SRC_C:src/%.c=$(TMP_LIBPNG)/%.o)
INCLUDE= $(LIBC_INCLUDE) $(LIBUNIX_INCLUDE) $(LIBZ_INCLUDE)

get:
	@./get.sh $(LIBPNG_VERSION)

dep:
	@makedepend -f - -D_LIGHTOS_LIBUNIX $(INCLUDE_MAKEDEPEND) $(INCLUDE) $(SRC_C) -p$(TMP_LIBPNG)/ > $(DEP)

-include $(DEP)

all: get dep $(BUILD)/$(ARCH)/lib/libpng.so

$(BUILD)/$(ARCH)/lib/libpng.so: $(OBJ_C)
	@echo " LD     libpng.so"
	@$(LD) -T $(LIB_LDSCRIPT_C) -shared -o $(BUILD)/$(ARCH)/lib/libpng.so -h/lib/libpng.so $(OBJ_C) $(LIBGCC)

$(TMP_LIBPNG)/%.o: src/%.c
	@echo " C      libpng/$(@:$(TMP_LIBPNG)/%.o=src/%.c)"
	@$(CC) -D_LIGHTOS_LIBUNIX -DPNG_NO_MMX_CODE -DPNG_SETJMP_NOT_SUPPORTED $(LIB_C_FLAGS) $(INCLUDE) -c $(@:$(TMP_LIBPNG)/%.o=src/%.c) -o $(@)

clean:
	@rm -rf libpng-$(LIBPNG_VERSION)
	@rm -f src $(DEP) $(OBJ_C) $(BUILD)/$(ARCH)/lib/libpng.so
